/* eslint-disable */
const path = require('path');
const webpack = require('webpack');

module.exports = {
  output: {
    path: path.join(__dirname, 'build'),
    chunkFilename: '[name].chunk.js',
    filename: 'bundle.js',
  },
  module: {
    rules: [
      {
        test: /(\.tsx?|\.js)$/,
        exclude: /node_modules\//,
        loader: 'babel-loader',
        include: path.join(__dirname, '/src'),
        options: {
          cacheDirectory: true,
        },
      },
      {
        test: /(\.tsx?|\.js)$/,
        exclude: /node_modules\//,
        loader: 'babel-loader',
        include: path.join(__dirname, '/.storybook'),
        options: {
          cacheDirectory: true,
        },
      },
      {
        test: /\.(eot|ttf|woff|woff2|jpg|png|svg|gif|pdf|jpeg)$/,
        type: 'asset/resource',
        generator: {
          filename: 'public/[name].[hash].[ext]',
        },
      },
    ],
  },
  resolve: {
    extensions: ['.json', '.mjs', '.js', '.ts', '.tsx'],
    alias: {
      'react-router-dom': path.resolve('./node_modules/react-router-dom'),
      types: path.resolve(__dirname, 'src/types/'),
      test: path.resolve(__dirname, 'test/'),
      'design-system': path.resolve(__dirname, 'src/design-system/'),
      store: path.resolve(__dirname, 'src/store.ts'),
      routes: path.resolve(__dirname, 'src/routes/'),
      components: path.resolve(__dirname, 'src/components/'),
      containers: path.resolve(__dirname, 'src/containers/'),
      hooks: path.resolve(__dirname, 'src/hooks/'),
      actions: path.resolve(__dirname, 'src/actions/'),
      reducers: path.resolve(__dirname, 'src/reducers/'),
      translations: path.resolve(__dirname, 'src/translations'),
      globalization: path.resolve(__dirname, 'src/globalization'),
      public: path.resolve(__dirname, 'src/public/'),
      styles: path.resolve(__dirname, 'src/styles/'),
      helpers: path.resolve(__dirname, 'src/helpers/'),
      api: path.resolve(__dirname, 'src/api/'),
      dataModel: path.resolve(__dirname, 'src/dataModel/'),
    },
    fallback: {
      path: require.resolve('path-browserify'),
      buffer: require.resolve('buffer'),
    },
  },
  externals: {
    moment: 'moment', // exclude from chart.js
  },
};
